<div id="app" v-cloak>
    <div id="aside" :style="{width:(isCollapse?'64px':'200px')}">
        <el-menu
                default-active="1-1"
                class="el-menu-vertical-demo"
                @open="handleOpen"
                @close="handleClose"
                @select="handleSelect"
                :unique-opened="true"
                :collapse="isCollapse"
                background-color="#545c64"
                text-color="#fff"
                active-text-color="#ffd04b">
            <el-submenu index="1">
                <template slot="title">
                    <i class="el-icon-setting"></i>
                    <span>系统设置</span>
                </template>
                <el-menu-item index="1-1">用户管理</el-menu-item>
                <el-menu-item index="1-2">机构管理</el-menu-item>
                <el-menu-item index="1-3">角色管理</el-menu-item>
            </el-submenu>
            <el-submenu index="2">
                <template slot="title">
                    <i class="el-icon-loading"></i>
                    <span slot="title">日志管理</span>
                </template>
                <el-menu-item index="2-1">登录日志</el-menu-item>
            </el-submenu>
        </el-menu>
    </div>

    <div id="main">
        <div id="head">
            <div id="header">
                <div class="collapseSwitch" @click="collapseSwitch">
                    <a v-if="isCollapse"><i class="el-icon-menu"></i></a>
                    <a v-if="!isCollapse"><i class="el-icon-menu"></i></a>
                </div>

                <a class="home" @click="onHome">首页</a>

                <div class="menu">
                    <ul>
                        <li>
                            <a>
                                <span style="line-height: 20px;"><el-badge is-dot class="item">消息</el-badge></span>
                            </a>
                        </li>
                        <li>
                            <el-dropdown>
                                <a class="el-dropdown-link">
                                    个人信息<i class="el-icon-arrow-down el-icon--right"></i>
                                </a>
                                <el-dropdown-menu slot="dropdown">
                                    <el-dropdown-item>修改信息</el-dropdown-item>
                                    <el-dropdown-item>修改密码</el-dropdown-item>
                                    <el-dropdown-item>退出登录</el-dropdown-item>
                                </el-dropdown-menu>
                            </el-dropdown>
                        </li>
                    </ul>
                </div>
            </div>
        </div>
        <div id="content">
            <el-tabs v-model="activeTabName" type="card" closable @tab-remove="removeTab">
                <el-tab-pane
                        v-for="(item, index) in tabs"
                        :key="item.name"
                        :label="item.title"
                        :name="item.name">
                    <iframe :src="item.url" style="width: 100%;height: 100%;border: 0;"></iframe>
                </el-tab-pane>
            </el-tabs>
        </div>
    </div>
</div>
<style>
    * {
        padding: 0;
        margin: 0;
    }

    body {
        overflow: hidden;
    }

    #app {
        display: flex;
        width: 100%;
        height: 100%;
    }

    #aside {
        transition: all 0.4s;
        background: #545c64;
    }

    #aside .el-menu {
        border-right: 0px
    }

    #main {
        flex-grow: 1;
    }

    #header {
        width: 100%;
        height: 50px;
        line-height: 50px;
        overflow: hidden;
        border-bottom: 1px solid #d6d6d6;
    }

    #header .collapseSwitch {
        display: inline-block;
        height: 50px;
        width: 50px;
        text-align: center;
        font-size: 20px;
        border-right: 1px solid #d6d6d6;
    }

    #header .collapseSwitch:hover {
        background: #f5f5f5;
    }

    #header .home {
        display: inline-block;
        color: #909399;
        transition: all 0.3s;
        vertical-align: top;
        padding-left: 12px;
    }

    #header .menu {
        display: inline-block;
        float: right;
    }

    #header .menu ul {
        display: inline-block;
    }

    #header .menu ul li {
        display: inline-block;
        vertical-align: top;
    }

    #header .menu ul li a {
        color: #909399;
        display: inline-block;
        text-align: center;
        position: relative;
        margin: 0px 15px;
        height: 50px;
        vertical-align: top;
    }

    #header .menu ul li a:after {
        content: "";
        display: inline-block;
        background: #409EFF;
        width: 0%;
        height: 2px;
        position: absolute;
        bottom: 2px;
        left: 50%;
        transition: all 0.3s;
    }

    #header .menu ul li a:hover {
        color: #409EFF;
    }

    #header .menu ul li a:hover:after {
        width: 100%;
        left: 0%;
    }

    #content {
        height: calc(100% - 52px);
    }

    #content .el-tabs__header {
        margin: 2px 0 2px;
    }

    #content > div {
        height: 100%;
    }

    #content > div > .el-tabs__content {
        padding: 0;
        height: calc(100% - 43px);
    }

    #content .el-tabs__nav {
        white-space: normal !important;
    }

    #content > div > .el-tabs__content .el-tab-pane {
        height: 100%;
        background: #f0f2f5;
    }

</style>
<script>
    var app = new Vue({
        el: "#app",
        data: {
            isCollapse: false,//左侧菜单是否收缩
            tabs: [],//所有Tabs
            activeTabName: '',
        },
        methods: {
            onHome: function () {
                this.addTab({
                    title: '首页',
                    name: 'home',
                    url: '/${contextPath}/home.htm'
                })
            },
            collapseSwitch: function () {
                this.isCollapse = !this.isCollapse;
            },
            handleOpen: function () {

            },
            handleClose: function () {

            },
            handleSelect: function (index) {
                switch (index) {
                    case "1-1":
                        this.addTab({title: "用户管理", name: "usersManager", url: "about:blank"});
                        break;
                    case "1-2":
                        this.addTab({title: "机构管理", name: "departmentsManager", url: "about:blank"});
                        break;
                    case "1-3":
                        this.addTab({title: "角色管理", name: "rolesManager", url: "about:blank"});
                        break;
                }
                return false;
            },
            addTab: function (tab) {
                //查找是否存在该tab
                var tempTabs = this.tabs.filter(function (tab_) {
                    return tab_.name === tab.name && tab_.url === tab.url;
                })
                //不存在则添加
                if (tempTabs.length <= 0) {
                    this.tabs.push(tab)
                }
                this.activeTabName = tab.name;
            },
            removeTab: function (tabName) {
                var activeName = this.activeTabName;
                var tempTabs = this.tabs;
                if (activeName === tabName) {
                    tempTabs.forEach(function (tab, index) {
                        if (tab.name === tabName) {
                            var nextTab = tempTabs[index + 1] || tempTabs[index - 1];
                            if (nextTab) {
                                activeName = nextTab.name;
                            }
                        }
                    });
                }
                this.activeTabName = activeName;
                this.tabs = tempTabs.filter(function (tab) {
                    return tab.name !== tabName
                })
            }
        },
        created: function () {
        },
        mounted: function () {
            this.onHome();//页面初始好后打开首页
        },
        watch: {}
    })
</script>

